<!-- 界面警情统计 -->
<template>
  <div class="container">
    <div class="titleBox">
      <div class="title">街面警情统计</div>
      <div class="btnBox"></div>
    </div>
    <div class="min_box">
      <div class="treeBox" :style="{ height: treeHeight }">
        <MOSTY.DepartmentTree
          width="280px"
          placeholder="管理部门ID"
          clearable
          filterable
          v-model="listQuery.deptId"
        />
      </div>
      <div class="flex_e">
        <div class="chart-box">
          <div class="searchBox single-chart-box">
            <div>今日警情处置分析</div>
            <div style="position: relative">
              <pie1 :data="jrjqCzfxData" />
            </div>
          </div>
          <div class="searchBox single-chart-box">
            <div>今日警情数量走势图</div>
            <div style="position: relative">
              <linechart :data="jrjqSlzsData" />
            </div>
          </div>
          <div class="searchBox single-chart-box">
            <div>今日警情数量预警图</div>
            <div style="position: relative">
              <ybp :data="jrjqYjData" />
            </div>
          </div>
        </div>
        <div class="chartAndTable-box">
          <div class="searchBox tab" :style="{ height: tableHeight+ 100 + 'px' }">
            <div class="mysearch" ref="searchBox">
              <el-form :model="listQuery" :inline="true">
                <el-form-item label="根据时间查询">
                  <el-date-picker
                    v-model="listQuery.name"
                    type="daterange"
                    unlink-panels
                    range-separator="至"
                    start-placeholder="开始日期"
                    end-placeholder="结束日期"
                    :size="size"
                  />
                </el-form-item>
                <el-form-item>
                  <el-button @click="handleFilter"> 查询 </el-button>
                  <el-button @click="reset()"> 重置 </el-button>
                </el-form-item>
              </el-form>
            </div>
            <div :style="{ height: tableHeight-10 + 'px' }" style="position:absolute;width:98%;">
              <el-table
                :data="tableData"
                border
                row-key="id"
                style="width: 100%"
                height="100%"
                :key="keyCount"
                v-loading="loadingTable"
                element-loading-background="rgba(0,0,0,0.3)"
                element-loading-text="数据加载中。。"
                @selection-change="handleSelectionChange"
              >
                <el-table-column label="序号" type="index" align="center" width="60"/>
                <el-table-column label="单位部门" prop="ssbm" align="center" />
                <el-table-column label="警情总数" prop="jqfskszs" align="center" />
                <el-table-column label="刑事警情" prop="jqfsksxs" align="center" />
                <el-table-column label="治安警情" prop="jqfsksyf" align="center" />
                <el-table-column label="交通警情" prop="jqjb" align="center" />
                <el-table-column label="消防救援" prop="xt_scbz" align="center" />
                <el-table-column label="群众求助" prop="xt_sjly" align="center" />
                <el-table-column label="应急联动" prop="xt_sjzt" align="center" />

                <el-table-column label="操作" align="center" fixed="right">
                  <template #default="{ row }">
                    <el-button @click="update(row)" size="small">详情</el-button>
                  </template>
                </el-table-column>
              </el-table>
              <el-pagination
                class="pagination"
                @size-change="handleSizeChange"
                @current-change="handleCurrentChange"
                :current-page="listQuery.pageCurrent"
                :page-sizes="[10, 20, 50, 100]"
                :page-size="listQuery.pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="total"
              >
              </el-pagination>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div class="dialog" v-if="dialogFormVisible">
      <div class="head_box">
        <span class="title">{{ title }}</span>
        <div>
          <el-button
            :loading="loading"
            type="primary"
            size="small"
            @click="submit"
            >保存</el-button
          >
          <el-button size="small" @click="close">关闭</el-button>
        </div>
      </div>
      <el-form
        ref="elform"
        :model="form"
        :rules="rules"
        :inline="true"
        label-position="top"
      >
        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入"></el-input>
        </el-form-item>
        <el-form-item prop="bz" label="备注" style="width: 100%">
          <el-input
            v-model="form.bz"
            placeholder="请输入关键字"
            show-word-limit
            type="textarea"
          />
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>
<script setup>
import {
  getJmjq,
  getJqlxTj,
  getJrjqTj,
  getJrjqSlzs,
  getJrjqYj
} from "@/api/patrolStatistics/interfaceAlarm.js";
import * as MOSTY from "@/components/MyComponents/index";
import { getTime } from "@/utils/time.js";
import pie1 from "./components/pie1.vue";
import pie2 from "./components/pie2.vue";
import linechart from "./components/line.vue";
import ybp from "./components/ybp.vue";
const treeHeight = ref(""); // 树高度
const treeHeightFn = () => {
  treeHeight.value = window.innerHeight - 192+ "px";
};
import { ref, getCurrentInstance, onMounted } from "vue";
const { proxy } = getCurrentInstance();
const { D_BZ_CZZT } = proxy.$dict("D_BZ_CZZT");
const keyCount = ref(0); //tabel组件刷新值
const form = ref({}); //新增表单
const tableData = ref([]); //表格数据
const total = ref(0);
const chackAdd = ref(false); //新增修改切换
const loading = ref(false); //新增保存按钮截流
const ids = ref([]); //表格选中id集合
const searchBox = ref(null); //搜索盒子
const loadingTable = ref(true); //表格加载状态
const tableHeight = ref(); // 表格高度
const dialogFormVisible = ref(false);
const title = ref("新增"); //弹窗标题
const elform = ref(null); //新增表单容器
const jrjqCzfxData = ref([]);
const jrjqLxData = ref([]);
const jrjqSlzsData = ref([
  { x: 2, y: 0 },
  { x: 4, y: 0 },
  { x: 6, y: 0 },
  { x: 8, y: 0 },
  { x: 10, y: 0 },
  { x: 12, y: 0 },
  { x: 14, y: 0 },
  { x: 16, y: 0 },
  { x: 18, y: 0 },
  { x: 20, y: 0 },
  { x: 22, y: 0 },
  { x: 24, y: 0 }
]);
const jrjqYjData = ref({
  total: 200,
  value: 0.0
});
const listQuery = ref({
  pageCurrent: 1,
  pageSize: 10
}); //搜索表单
//表单验证
const rules = ref({
  name: [{ required: true, message: "请输入名称", trigger: "change" }]
});

// 获取列表
function getListData() {
  loadingTable.value = true;
  getJmjq(listQuery.value).then((res) => {
    tableData.value = res.records;
    total.value = res.total;
    loadingTable.value = false;
  }).catch(()=>{
    loadingTable.value = false;
  });
}
// 获取图表数据
function getEchData() {
  getJqlxTj().then((res) => {
    jrjqLxData.value = res.map((item) => {
      return {
        name: item.bjlx,
        value: item.sl
      };
    });
  });
  getJrjqTj().then((res) => {
    jrjqCzfxData.value = res.map((item) => {
      return {
        name: D_BZ_CZZT.value.filter((e) => {
          return e.value == item.type;
        })[0].label,
        value: item.data
      };
    });
  });
  getJrjqSlzs().then((res) => {
    jrjqSlzsData.value = res
  });
  getJrjqYj({
    kssj: getTime(0) + " " + "00:00:00",
    jssj: getTime(0) + " " + "23:59:00"
  }).then((res) => {
    jrjqYjData.value.value = res[0].sl;
  });
}
//打开新增弹窗
function add() {
  chackAdd.value = true;
  dialogFormVisible.value = true;
}
//关闭弹窗
function close() {
  dialogFormVisible.value = false;
  form.value = {};
}
//提交
function submit() {
  elform.value.validate((valid) => {
    if (valid) {
      loading.value = true;
      setTimeout(() => {
        loading.value = false;
      }, 1500);
      if (chackAdd.value) {
        proxy.$message({
          type: "success",
          message: "新增成功"
        });
      } else {
        proxy.$message({
          type: "success",
          message: "修改成功"
        });
      }
    }
  });
}
//修改
function update(row) {
  // API(row.id).then((res) => {
  //   form.value = res;
  // });
  chackAdd.value = false;
  form.value = row;
  title.value = "修改";
  dialogFormVisible.value = true;
}
//批量数据
const handleSelectionChange = (val) => {
  ids.value = [];
  if (val) {
    val.forEach((item) => {
      ids.value.push(item.id);
    });
  }
};
//删除
function delDictItem(row) {
  proxy
    .$confirm("确定要删除", "警告", {
      type: "warning"
    })
    .then(() => {
      // DELETE([row.id]).then(() => {
      //   proxy.$message({
      //     type: "success",
      //     message: "删除成功"
      //   });
      //   getListData();
      // });
    })
    .catch(() => {
      proxy.$message.info("已取消");
    });
}
//批量删除
function batchDelete() {
  proxy
    .$confirm("确定要删除", "警告", {
      type: "warning"
    })
    .then(() => {
      //       DELETE(ids.value).then((res) => {
      //         proxy.$message({
      //           message: "删除成功",
      //           type: "success"
      //         });
      //         getListData();
      //       });
    })
    .catch(() => {
      proxy.$message.info("已取消");
    });
}
//点击查询
const handleFilter = () => {
  listQuery.value.page = 1;
  getListData();
};
//点击重置
const reset = () => {
  listQuery.value = {
    page: 1,
    size: 10
  };
  getListData();
};
// 表格高度计算
const tabHeightFn = () => {
  tableHeight.value = window.innerHeight - searchBox.value.offsetHeight - 538;
};
/**
 * size 改变触发
 */
const handleSizeChange = (currentSize) => {
  listQuery.value.size = currentSize;
  getListData();
};

/**
 * 页码改变触发
 */
const handleCurrentChange = (currentPage) => {
  listQuery.value.page = currentPage;
  getListData();
};
onMounted(() => {
  getListData();
  tabHeightFn();
  treeHeightFn();
  getEchData();
  window.onresize = function () {
    tabHeightFn();
    treeHeightFn();
    keyCount.value = 1;
    setTimeout(() => {
      keyCount.value = 0;
    }, 100);
  };
  proxy.mittBus.on("mittFn", (data) => {
    keyCount.value = data;
  });
});
</script>
<style lang="scss" scoped>
@import "~@/assets/css/layout.scss";
@import "~@/assets/css/element-plus.scss";
.chart-box {
  display: flex;
  justify-content: space-between;
}
.tab {
  width: 100%;
}
.single-chart-box {
  height: 280px;
  width: 30%;
  box-sizing: border-box;
}
.chartAndTable-box {
  margin-top: 15px;
  display: flex;
  justify-content: space-between;
}
.left-box {
  width: 32%;
  box-sizing: border-box;
}
.right-table {
  width: 100%;
  box-sizing: border-box;
}
.min_box {
  display: flex;
  .flex_e {
    flex: 1;
  }
}
// .container{
// width: 1639px;
// }
.mysearch {
  width: 100%;
  overflow: hidden;
}
</style>
